function [DeltaM1,DeltaM2] = DistanciaParesMuestras(M1,M2,M3,M4)
%function [DeltaM1 DeltaM2] = DistanciaParesMuestras(M1,M2,M3,M4)
%Funcion que calcula la dos distancias entre dos pares de muestras
%correspondientes a la mnima entre las posibles.

DM1M3 = sqrt(sum((M1-M3).^2));
DM2M4 = sqrt(sum((M2-M4).^2));
Pos1 = DM1M3 + DM2M4;

DM1M4 = sqrt(sum((M1-M4).^2));
DM2M3 = sqrt(sum((M2-M3).^2));
Pos2 = DM1M4 + DM2M3;

if (Pos1 < Pos2)
    DeltaM1 = DM1M3;
    DeltaM2 = DM2M4;
    %'Pos1'
else
    DeltaM1 = DM1M4;
    DeltaM2 = DM2M3;
    %'Pos2'
end
