function [DatosOut,ParesInconsistentes]= InconsistenciesFuzzyRule1(DatosIn,umbral)


%28/10/2015
%Primero hay que pasar todo el calculo individual y sacar los vecinos. Con
%la matriz resultante volver a pasar todo el calculo y sacar los pares
%inconsistentes y meterlos en otra matriz aadiendo los vecinos de cada uno
%calculados previamente. Esta por hacer. Luego hay que hacer la version de
%la otra regla fuzzy.

[a b] = size(DatosIn);
%a debe ser 11
%Datos out sera como DatosIn pero aadiendo el grado fuzzy de confianza...
DatosOut = zeros(14,b);
ParesInconsistentes = zeros(1,11);
%figure
%Para cada dato del conjunto
for i=1:1:b
    i
    ParActuali = DatosIn(:,i); %Par a analizar
    InconsistenciaDE00i = 0;
    InconsistenciaDE00iMax = 0;
    NVecinosi = 0;
    NVecinosTi = 0;
    %Vamos a calcular el grado mximo y medio de inconsistencia analizando dato por dato
    %analizamos del siguiente en adelante
    for j=(i+1):1:b
        if (i==j) 
            %No hacemos nada
        else
            ParActualj = DatosIn(:,j);
            %ParActuali
            %ParActualj
        
            %Ahora calculamos la distancia entre los dos pares y los grados en
            %que son pequeas
            [DeltaM1 DeltaM2] = DistanciaParesMuestras(ParActuali(2:4),ParActuali(5:7),ParActualj(2:4),ParActualj(5:7));
            DeltaM1P = 1-SMshp(DeltaM1,1,5);
            DeltaM2P = 1-SMshp(DeltaM2,1,5);
                
            %Diferencia entre los DE00s y grado en que es pequea
            DE001 = ParActuali(10);
            DE002 = ParActualj(10);
            DDE00 = abs(DE001-DE002);
            DDE00P = 1-SMshp(DDE00,0.2,1);
        
            %Diferencia entre los DVs y grado en que es grande
            DV1 = ParActuali(9);
            DV2 = ParActualj(9);
            DDV = abs(DV1-DV2);
            DDVG = SMshp(DDV,1,2);
        
            %Grado de vecindad entre las muestras i y j
            GradoVecindad = DeltaM1P*DeltaM2P*DDE00P;
        
            %acumulamos el nmero de vecinos como la suma de las certezas de
            %los 3 primeros antecedentes de la regla DelaM1P, DeltaM2P y DDEP
            NVecinosi = NVecinosi + GradoVecindad;

            %Grado de inconsistencia de la muestra i respecto a la j
            GradoDE00 = DeltaM1P*DeltaM2P*DDE00P*DDVG;
            
            %Si el grado es superior a un umbral, metemos las dos muestras
            %en el conjunto de pares inconsistentes
            if (GradoDE00 > umbral)
                ParesInconsistentes = [ParesInconsistentes;
                                       [ParActuali' GradoDE00];
                                       [ParActualj' GradoDE00]]
            end
        
            %sumamos las inconsistencias ponderadas por el grado de vecindad
            InconsistenciaDE00i = InconsistenciaDE00i + GradoVecindad*GradoDE00;
            %Luego dividiremos por el nmero de vecinos para normalizar
        
            %acumulamos el nmero de vecinos totales como aquellos que tienen
            %el Grado de vecindad distinto de 0
            if ( GradoVecindad > 0)
                NVecinosTi = NVecinosTi + 1;
            end
            if (GradoDE00 > InconsistenciaDE00iMax)
                InconsistenciaDE00iMax = GradoDE00;
            end
            %Inconsistenciai
            %pause
        end        
    end
    %normalizamos la media ponderada
    if (NVecinosi > 0)
        InconsistenciaDE00i = InconsistenciaDE00i/NVecinosi;
    else %Si no hay vecinos, no podemos decir que sea inconsistente
        InconsistenciaDE00i = 0;
    end
    
    DatosOut(:,i) = [ParActuali; NVecinosi; NVecinosTi; InconsistenciaDE00i; InconsistenciaDE00iMax ];
end
            
        
        
